#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <time.h>
#include <limits.h>
#include <string.h>
#include <malloc.h>
#include <libintl.h>
#include <langinfo.h>
#define _(String) gettext (String)
#include "config.h"
#include "str.h"
#include "lst.h"

/*
#define TEST 1
*/

#define COPYBUFLEN 1024

struct config_s{
	int mime;
	int localtime;
	int i18n;
	size_t maxsize;
	String me;
}config={0,0,0};

char *months[]={"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec",NULL};

int readline(String *str,FILE *f){
int c;

	str_clear(str);
	while(1){
		c=fgetc(f);
		if (c<0) return -1;
		if (c==0){
			str_addchar(str,'^');
			str_addchar(str,'@');
		}
/*		else if (c=='\r'){
			c=fgetc(f);
			if (c!='\n'){
				fprintf(stderr,"qmail-superbounce: CR without LF\n");
				exit(111);
			}
			break;
		}*/
		else if (c=='\n'){
			break;
		}
		else str_addchar(str,c);
	}
	return 0;
}

List * parse_to(List *lst,char *str){
int i,begin,end;
int angl,comment,quote,err;
int theend;
String s;

	str_init(&s);

	/* find the begining */
	for(i=0;str[i]==' '||str[i]=='\t';i++);
	begin=i;

	/* find the end */
	quote=0; angl=0; err=0; comment=0; 
	/* angl==0: before '<' ; angl==1: in "<>" ; angl==-1: after ">" */ 
	for(i=begin;str[i];i++){
		if (str[i]=='"') quote=!quote;
		else if (!quote){
			if (str[i]==',' && !comment) break; 
			else if (str[i]=='<' && !comment) 
				if (angl) { err=1; break; }
				else {
					angl=1;
					str_clear(&s);
				}
			else if (str[i]=='>' && !comment)
				if (angl!=1) { err=1; break; }
				else angl=-1;
			else if (str[i]=='(' && !angl)
				if (comment) { err=1; break; }
				else comment=1;
			else if (str[i]==')' && !angl)
				if (!comment) { err=1; break; }
				else comment=0;
			else if (angl!=-1){
				str_addchar(&s,str[i]);
			}
		}
	}
	if (quote || err || comment || angl==1 ){
		fprintf(stderr,"qmail-superbounce: Address format error\n");
		exit(100);
	}
	if (str[i]) theend=1;
	else theend=0;
	
	/* strip the spaces */
	while(i>begin && (str[i-1]==' ' || str[i-1]=='\t')) i--;
	end=i;
	if (end==begin) return lst;
	if (str[end]) lst=parse_to(lst,str+end+1);
	str[end]=0;
	str_make(&s,str+begin);
	lst=lst_append(lst,&s);
	return lst;
}

char boundary[51];

void read_config(){
FILE *f;
String str;

	str_init(&str);
	str_init(&config.me);
	f=fopen(CONTROLDIR "/me","r");
	if (f){
		readline(&config.me,f);
		fclose(f);
	}
	f=fopen(CONTROLDIR "/superbounce","r");
	if (f){
		while(!readline(&str,f))
			if (str.s[0]=='#' || str.s[0]==0 ) continue;
			else if (strcmp(str.s,"i18n")==0) config.i18n=1;
			else if (strcmp(str.s,"mime")==0) config.mime=1;
			else if (strcmp(str.s,"localtime")==0) config.localtime=1;
			else if (cmpstart(&str,"maxsize=")==0){
				config.maxsize=atoi(str.s+strlen("maxsize="));
				if (config.maxsize<0) config.maxsize=0;
			}
			else fprintf(stderr,"qmail-superbounce: Config error: %s\n",str.s);
		fclose(f);
	}
}

void start_i18n(char *addr){
FILE *f;	
String str;
char *ptr,*ptr1;
int alen,dlen;

	str_init(&str);

	if (!addr) return;
	alen=strlen(addr);

	f=fopen(CONTROLDIR "/superbounce-domains","r");
	if (f){
		while(!readline(&str,f)){
			if (str.s[0]==0 || str.s[0]=='#') continue;
			
			ptr=strchr(str.s,':');
			if (ptr) *ptr++=0;
			
			if (str.s[0]=='.') ptr1=str.s+1;
			else ptr1=str.s;

			dlen=strlen(ptr1);

			if (alen>dlen && addr[alen-dlen-1]=='.'
					&& strcasecmp(addr+alen-dlen,ptr1)==0){
				if (!ptr || *ptr==0 ) break;
				setlocale(LC_CTYPE,ptr);
				setlocale(LC_MESSAGES,ptr);
				bindtextdomain(PACKAGE,LOCALEDIR);
				textdomain(PACKAGE);
			}
		}
		fclose(f);
	}
}

int putline_qp(FILE *f,String *str){
char *s;
int i,j;

	s=str->s;
	for(i=0,j=0;s[i];i++){
		if (s[i]==' ' && s[i+1]==0){
			fprintf(f,"=20");
			j+=3;
		}
		else if (s[i]=='\t' && s[i+1]==0){
			fprintf(f,"=09");
			j+=3;
		}
		else if ((s[i]>=32 && s[i]<=60) || (s[i]>=62 && s[i]<=126) || s[i]=='\t'){
			fputc(s[i],f);
			j++;
		}
		else {
			fprintf(f,"=%02X",(int)(unsigned char)s[i]);
			j+=3;
		}
		if (j>72){
			fprintf(f,"=\n");
			j=0;
		}
	}
	fputc('\n',f);
	return 0;
}

void translate_msg(String *str,String *str1){
static char buf[101];
char *ptr;

	if (cmpstart(str,"Remote host said: ")==0){
		str_make(str1,_("Remote host said: "));
		str_add(str1,str->s+strlen("Remote host said: "));
	}
	else if (cmpstart(str,"Giving up on ")==0){
		str_make(str1,_("Giving up on "));
		str_add(str1,str->s+strlen("Giving up on "));
	}
	else if (cmpstart(str,"Sorry, I couldn't find any host named ")==0){
		str_make(str1,_("Sorry, I couldn't find any host named "));
		str_add(str1,str->s+strlen("Sorry, I couldn't find any host named "));
	}
	else if (cmpend(str," does not like recipient.")==0){
		str_maken(str1,str->s,str->l-strlen(" does not like recipient."));
		str_add(str1,_(" does not like recipient."));
	}
	else if (cmpend(str," failed on DATA command")==0){
		str_maken(str1,str->s,str->l-strlen(" failed on DATA command"));
		str_add(str1,_(" failed on DATA command"));
	}
	else if (cmpend(str," failed after I sent the message")==0){
		str_maken(str1,str->s,str->l-strlen(" failed after I sent the message"));
		str_add(str1,_(" failed after I sent the message"));
	}
	else if (cmpstart(str,"Connected to ")==0){
		str_make(str1,_("Connected to "));
		sscanf(str->s+strlen("Connected to "),"%100s",buf);
		str_add(str1,buf);
		ptr=strchr(str->s+strlen("Connected to "),' ');
		if (ptr) str_add(str1,gettext(ptr));
	}	
	else str_make(str1,gettext(str->s));
}

int main(int argc,char *argv[]){
String str,str1;
List *headers;
List *body;
List *recipients;
List *it;
int r,r1,i;
char *ptr;
char *copybuf;
char c;
int msg_pipe[2];
int rcpt_pipe[2];
pid_t pid;
char *charset;
int eightbit=0;
FILE *mp,*rp;
size_t readed;

	read_config();

	srand(time(0)+256*getpid());	
	headers=NULL;
	recipients=NULL;
	str_init(&str);
	str_init(&str1);
	while(1){
		r=readline(&str,stdin);
		if (r<0){
			fprintf(stderr,"qmail-superbounce: No body\n");
			exit(100);
		}
		if (str.s[0]==0) break;
		if (str.s[0]==' ' || str.s[0]=='\t'){
			if (headers==NULL){
				fprintf(stderr,"qmail-superbounce: Message syntax error\n");
				exit(100);
			}
			else{
				str_addchar(&headers->string,'\n');
				str_addstr(&headers->string,&str);
			}
		}
		ptr=strstr(str.s,": ");
		if (ptr==NULL){
			fprintf(stderr,"qmail-superbounce: Message syntax error\n");
			exit(100);
		}
		if (strncasecmp(str.s,"Received: ",strlen("Received: "))==0){
			ptr=strstr(str.s,"for bounce");
			if (ptr==NULL){
				fprintf(stderr,"qmail-superbounce: Not a bounce\n");
				exit(100);
			}
		}
		if (strncasecmp(str.s,"Date: ",strlen("Date: "))==0 && config.localtime){
			struct tm tm;
			char hourb[9];
			char zoneb[6];
			char monthb[4];

			memset(&tm,0,sizeof(tm));
		
			ptr=strchr(str.s+strlen("Date: "),',');
			if (!ptr) ptr=str.s+strlen("Date: ");
			else ptr+=1;
			
			r=sscanf(ptr,"%u %3s %u %8s %5s",&tm.tm_mday,monthb,&tm.tm_year,hourb,zoneb);
			if (tm.tm_year>99) tm.tm_year-=1900;
			if (r!=5 || tm.tm_mday>31 || tm.tm_mday<1) 
				fprintf(stderr,"qmail-superbounce: Couldn't parse date\n");
			else {
				tm.tm_mon=INT_MAX;
				for(i=0;months[i];i++)
					if (strcmp(monthb,months[i])==0){
						tm.tm_mon=i;
						break;
					}
				
				tm.tm_hour=INT_MAX; tm.tm_min=INT_MAX;
				r=sscanf(hourb,"%2u:%2u:%2u",&tm.tm_hour,&tm.tm_min,&tm.tm_sec);

				tm.tm_gmtoff=INT_MAX;
				if (zoneb[0]=='+') 
					tm.tm_gmtoff=3600*atoi(zoneb+1)/100+60*atoi(zoneb+1)%100;
				else if (zoneb[0]=='-') 
					tm.tm_gmtoff=3600*atoi(zoneb+1)/100+60*atoi(zoneb+1)%100;
				else if (strcmp(zoneb,"UT")==0) tm.tm_gmtoff=0;
				else if (strcmp(zoneb,"GMT")==0) tm.tm_gmtoff=0;
				tm.tm_isdst=-1;

				if (tm.tm_hour>24 || tm.tm_min>60 
						|| tm.tm_gmtoff==INT_MAX || tm.tm_mon>11)
					fprintf(stderr,"qmail-superbounce: Couldn't parse date\n");
				else{		
					char buf[100];
					time_t t;
					struct tm *tm1;
					char *tmpenv;
					
					tmpenv=getenv("TZ");
					setenv("TZ",zoneb,1);
					t=mktime(&tm);
					if (tmpenv) setenv("TZ",tmpenv,1);
					else unsetenv("TZ");
					tm1=localtime(&t);
				
					str_clear(&str);
					str_add(&str,"Date: ");
					strftime(buf,100,"%a, %d %b %Y %H:%M:%S %z",tm1);
					str_add(&str,buf);
					headers=lst_append(headers,&str);
					continue;
				}
			}
		}
		if (strncasecmp(str.s,"To: ",strlen("To: "))==0){
			recipients=parse_to(recipients,str.s+strlen("To: "));
		}
		if (strncasecmp(str.s,"Content-Type: ",strlen("Content-Type: "))==0
		    || strncasecmp(str.s,"MIME-Version: ",strlen("MIME-Version: "))==0){
			fprintf(stderr,"qmail-superbounce: It seems to be already a MIME message\n");
			exit(100);
		}
		headers=lst_append(headers,&str);
	}
		
	if (recipients==NULL){
		fprintf(stderr,"qmail-superbounce: No recipient found\n");
		exit(100);
	}

	if (config.i18n) start_i18n(recipients->string.s);

	if (config.mime){
		boundary[0]='=';
		boundary[1]='=';
		for(i=2;i<48;i++){
			r=(int)(62.0*rand()/RAND_MAX);
			if (r<10) c=r+'0';
			else if (r<36) c=r+'A'-10;
			else c=r+'a'-36;
			boundary[i]=c;
		}
		boundary[i++]='=';
		boundary[i++]='=';
		boundary[i]=0;
	
		str_make(&str,"MIME-Version: 1.0"); headers=lst_append(headers,&str);
		str_make(&str,"Content-Type: multipart/mixed; boundary=\"");
		str_add(&str,boundary); str_addchar(&str,'\"');
		headers=lst_append(headers,&str);
	}

	body=NULL;
	if (config.i18n){
		charset=nl_langinfo(CODESET);
		if (!charset || strncmp(charset,"ANSI_X3.4",strlen("ANSI_X3.4"))==0)
									charset="US-ASCII";
		if (strcasecmp(charset,"us-ascii")!=0) eightbit=1;
		
		/* read the generic message */
		while(1){
			r=readline(&str,stdin);
			if (r<0){
				fprintf(stderr,"qmail-superbounce: Strange bounce messsage\n");
				exit(100);
			}
			if (str.s[0]==0) break;
		}
		str_make(&str,_("Hi. This is the qmail-send program at"));
		str_addchar(&str,' '); str_addstr(&str,&config.me); str_addchar(&str,'.');
		body=lst_append(body,&str);
		str_make(&str,_("I'm afraid I wasn't able to deliver your message to the following addresses."));
		body=lst_append(body,&str);
		str_make(&str,_("This is a permanent error; I've given up. Sorry it didn't work out."));
		body=lst_append(body,&str);
		str_clear(&str);
		body=lst_append(body,&str);
		
		/* read the address/reason pairs */
		while(1){	
			r=readline(&str,stdin);
			if (r<0){
				fprintf(stderr,"qmail-superbounce: Strange bounce messsage\n");
				exit(100);
			}
			if (cmpstart(&str,"--- Below")==0) break;
			if (str.s[str.l-1]==':'){
				body=lst_append(body,&str);
				while(1){
					r=readline(&str,stdin);
					if (r<0){
						fprintf(stderr,"qmail-superbounce: Strange bounce messsage\n");
						exit(100);
					}
					if (str.s[0]==0){
						body=lst_append(body,&str);
						break;
					}
					translate_msg(&str,&str1);
					body=lst_append(body,&str1);
				}
			}
			else body=lst_append(body,&str);
		}
	}
	else while(1){
		r=readline(&str,stdin);
		if (r<0){
			fprintf(stderr,"qmail-superbounce: Strange bounce messsage\n");
			exit(100);
		}
		if (cmpstart(&str,"--- Below")==0) break;
		body=lst_append(body,&str);
	}

	if (config.maxsize){
		char numbuf[16];
		str_make(&str,"");
		body=lst_append(body,&str);
		str_make(&str,_("Attached message contains no more than "));
		sprintf(numbuf,"%i",(int)config.maxsize);
		str_add(&str,numbuf);
		str_add(&str,_(" bytes of original message."));
		body=lst_append(body,&str);
		str_make(&str,"");
		body=lst_append(body,&str);
	}

#ifdef TEST
	mp=stdout;
	rp=fopen("/dev/null","w");
#else
	if (pipe(msg_pipe)){
		perror("qmail-superbounce");
		exit(111);
	}
	if (pipe(rcpt_pipe)){
		perror("qmail-superbounce");
		exit(111);
	}
	pid=fork();
	if (pid == (pid_t) 0){
		/* child process */
		close(msg_pipe[1]);
		close(rcpt_pipe[1]);
		dup2(msg_pipe[0],0);
		dup2(rcpt_pipe[0],1);
		execl(QMAIL_QUEUE,QMAIL_QUEUE,NULL);
		perror("qmail-superbounce");
		exit(1);
	}

	close(msg_pipe[0]);
	close(rcpt_pipe[0]);
	mp=fdopen(msg_pipe[1],"w");
	rp=fdopen(rcpt_pipe[1],"w");
#endif
	
	for(it=lst_first(headers);it;it=it->next)
		fprintf(mp,"%s\n",it->string.s);
	if (config.mime){
		fprintf(mp,"\n");
		fprintf(mp,"This is MIME-encoded message.\n\n");
		fprintf(mp,"--%s\n",boundary);
		if (config.i18n)
			fprintf(mp,"Content-Type: text/plain; charset=\"%s\"\n",charset);
		else fprintf(mp,"Content-Type: text/plain\n");
		if (eightbit)
			fprintf(mp,"Content-Transfer-Encoding: quoted-printable\n");
	}
	fprintf(mp,"\n");

	if (config.mime && eightbit)
		for(it=lst_first(body);it;it=it->next)
			putline_qp(mp,&it->string);
	else
		for(it=lst_first(body);it;it=it->next)
			fprintf(mp,"%s\n",it->string.s);
	
	if (config.mime){
		fprintf(mp,"--%s\n",boundary);
		fprintf(mp,"Content-Type: message/rfc822\n");
	}
	else fprintf(mp,"--- Below this line is a copy of the message.\n");

	copybuf=(char *)malloc(COPYBUFLEN);
	if (copybuf==NULL){
		fprintf(stderr,"qmail-superbounce: Out of memory\n");
		exit(111);
	}

	while(1){
		r=fread(copybuf,1,COPYBUFLEN,stdin);
		if (r<=0) break;
		readed+=r;
		if (config.maxsize && readed>config.maxsize) r-=readed-config.maxsize;
		r1=fwrite(copybuf,1,r,mp);
		if (r1!=r){
			perror("qmail-superbounce");
			exit(111);
		}
		if (config.maxsize && readed>config.maxsize) break; 
	};
	if (config.mime) fprintf(mp,"--%s--\n",boundary);
	fclose(mp);

	fputc('F',rp); fputc(0,rp);
	for(it=lst_first(recipients);it;it=it->next){
		fprintf(rp,"T%s",it->string.s);
		fputc(0,rp);
	}
	fputc(0,rp);

#ifndef TEST
	fclose(rp);
	waitpid(pid,&r,0);
#endif
	if (r!=0){
		if (WIFEXITED(r)){
			fprintf(stderr,"qmail-superbounce: qmail-queue failed. Error code: %i\n",WEXITSTATUS(r));
			exit(WEXITSTATUS(r));
		}
		else
			exit(100);
	}
	
/*	
	str_make(&str,"This is MIME-encoded message.\n\n"); headers=lst_append(headers,&str);
	str_make(&str,"--"); str_add(&str,boundary); str_add(&str,"\n");
	headers=lst_append(headers,&str);
	str_make(&str,"Content-Type: text/plain; charset=iso-8859-2\n");i
	headers=lst_append(headers,&str);
*/	
	return 0;
}

