#include <string.h>
#include <stdio.h>
#include <malloc.h>
#include "str.h"

void str_init(String *str){

	str->s=(char *)malloc(CHUNK);
	if (str->s==NULL){
		fprintf(stderr,"qmail-superbounce: Out of memory\n");
		exit(111);
	}
	str->a=CHUNK;
	str->l=0;
	*(str->s)=0;
}

void str_make(String *str,char *s){
int len;

	if (str->s) free(str->s);
	len=strlen(s);
	str->s=(char *)malloc(len+1);
	if (str->s==NULL){
		fprintf(stderr,"qmail-superbounce: Out of memory\n");
		exit(111);
	}
	str->a=len+1;
	str->l=len;
	strcpy(str->s,s);
}

void str_maken(String *str,char *s,int n){
int len;

	if (str->s) free(str->s);
	len=strlen(s);
	len=(len>n)?n:len;
	str->s=(char *)malloc(len+1);
	if (str->s==NULL){
		fprintf(stderr,"qmail-superbounce: Out of memory\n");
		exit(111);
	}
	str->a=len+1;
	str->l=len;
	memcpy(str->s,s,len);
	str->s[len]=0;
}

void str_free(String *str){

	if (str->s && str->a) free(str->s);
	str->a=0;
	str->l=0;
}

void str_clear(String *str){

	str->l=0;
	str->s[0]=0;
}

void str_addchar(String *str,char c){

	if (str->a < str->l+2){
		str->a+=CHUNK;
		str->s=realloc(str->s,str->a);
		if (str->s==NULL){
			fprintf(stderr,"qmail-superbounce: Out of memory\n");
			exit(111);
		}
	}
	str->s[str->l++]=c;
	str->s[str->l]=0;
}

void str_add(String *str,char *s){
int len;

	if (!s) return;
	len=strlen(s);
	if (str->a < str->l+len+1){
		str->a+=len+1;
		str->s=realloc(str->s,str->a);
		if (str->s==NULL){
			fprintf(stderr,"qmail-superbounce: Out of memory\n");
			exit(111);
		}
	}
	strcpy(str->s+str->l,s);
	str->l+=len;
}

void str_addstr(String *str,String *s){

	if (str->a < str->l+s->l+1){
		str->a+=s->l+1;
		str->s=realloc(str->s,str->a);
		if (str->s==NULL){
			fprintf(stderr,"qmail-superbounce: Out of memory\n");
			exit(111);
		}
	}
	memcpy(str->s+str->l,s->s,s->l+1);
	str->l+=s->l;
}

void str_dup(String *newstr,String *str){

	str_init(newstr);
	str_addstr(newstr,str);
}

int cmpstart(String *str,const char *pattern){

	return strncmp(str->s,pattern,strlen(pattern));
}

int cmpend(String *str,const char *pattern){

	return strcmp(str->s+str->l-strlen(pattern),pattern);
}
